"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

var _ej2ReactTreegrid = require("@syncfusion/ej2-react-treegrid");

var _react = _interopRequireWildcard(require("react"));

var _datasource = require("../datasource");

require("./material.css");

require("./TreeGrid.css");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const TreeGrid = () => {
  const [editOptions, setEditOptions] = (0, _react.useState)({
    allowAdding: true,
    allowDeleting: true,
    allowEditing: true,
    newRowPosition: "Below" // mode: 'Cell'

  });
  const [data, setData] = (0, _react.useState)([]);
  const [keys, setKeys] = (0, _react.useState)([]);
  const [inputColumn, setInputColumn] = (0, _react.useState)("");
  const [expanded, setExpanded] = (0, _react.useState)(false);
  const ref = (0, _react.useRef)();
  const [toolbarSettings, setToolbarSettings] = (0, _react.useState)(["Add"]);
  const [selectedColumns, setSelectedColumns] = (0, _react.useState)([]);
  (0, _react.useEffect)(() => {
    setData(_datasource.summaryData);
  }, [_datasource.summaryData]);
  (0, _react.useEffect)(() => {
    if (data.length !== 0) {
      let keysarr = Object.keys(data[0]).filter(key => key !== "category").filter(key => key !== "subtask");
      let initialArray = ["category"];
      initialArray.push(...keysarr);
      setKeys(initialArray);
    }
  }, [data]);
  (0, _react.useEffect)(() => {
    if (!expanded) {
      var elements = document.getElementsByClassName("e-headercelldiv");

      for (var i = 0; i < elements.length; i++) {
        elements[i].classList.add("hide-treegridheader");
        elements[i].classList.remove("show-treegridheader");
      }
    }

    if (expanded) {
      var elements = document.getElementsByClassName("e-headercelldiv");

      for (var i = 0; i < elements.length; i++) {
        elements[i].classList.add("show-treegridheader");
        elements[i].classList.remove("hide-treegridheader");
      }
    }
  }, [expanded]);
  (0, _react.useEffect)(() => {
    setTimeout(() => {
      var elements = document.getElementsByClassName("e-headercelldiv");

      for (var i = 0; i < elements.length; i++) {
        elements[i].classList.add("hide-treegridheader");
        elements[i].classList.remove("show-treegridheader");
      }

      var contentelements = document.getElementsByClassName("e-content");

      for (var i = 0; i < contentelements.length; i++) {
        contentelements[i].classList.add("hide-contentoverflow");
      }
    }, 100);
  }, []);

  const customizeCell = args => {
    const cell = args.cell;

    if (args.column.field !== "category") {
      cell.setAttribute("style", "background-color:#F4F5F7;background-clip:content-box;padding: 8px 21px;");
    }
  };

  const addColumn = inp => {
    let updated = data.map(obj => _objectSpread(_objectSpread({}, obj), {}, {
      [inp]: ""
    }));
    setData(updated);
    ref.current.refresh();
  };

  const autoFit = () => {
    ref.current.autoFitColumns(["category"]);
  };

  const handleExpand = () => {
    setExpanded(true);
    var elements = document.getElementsByClassName("e-rowcell");

    for (var i = 0; i < elements.length; i++) {
      elements[i].classList.add("show-treegridborder");
      elements[i].classList.remove("hide-treegridborder");
    }

    var contentelements = document.getElementsByClassName("e-content");

    for (var i = 0; i < contentelements.length; i++) {
      contentelements[i].classList.add("show-contentoverflow");
      contentelements[i].classList.remove("hide-contentoverflow");
    }
  };

  const handleCollapse = () => {
    setExpanded(false);
    var elements = document.getElementsByClassName("e-rowcell");

    for (var i = 0; i < elements.length; i++) {
      elements[i].classList.add("hide-treegridborder");
      elements[i].classList.remove("show-treegridborder");
    }

    var contentelements = document.getElementsByClassName("e-content");

    for (var i = 0; i < contentelements.length; i++) {
      contentelements[i].classList.add("hide-contentoverflow");
      contentelements[i].classList.remove("show-contentoverflow");
    }
  };

  const handleColumnSelect = e => {
    if (e.target.checked) {
      setSelectedColumns(prevState => prevState.concat(e.target.name));
    } else {
      setSelectedColumns(prevState => prevState.filter(item => item !== e.target.name));
    }
  };

  const handleDeleteRollup = () => {
    for (var j = 0; j < data.length; j++) {
      for (var i = 0; i < selectedColumns.length; i++) {
        var x = data[j];

        if (x.hasOwnProperty(selectedColumns[i])) {
          delete x[selectedColumns[i]];
        }

        if (x.hasOwnProperty("subtask")) {
          for (var k = 0; k < x.subtask.length; k++) {
            for (var i = 0; i < selectedColumns.length; i++) {
              var y = x.subtask[k];

              if (y.hasOwnProperty(selectedColumns[i])) {
                delete y[selectedColumns[i]];
              }
            }
          }
        }
      }
    }

    ref.current.refresh();
    setTimeout(() => {
      if (data.length !== 0) {
        let keysarr = Object.keys(data[0]).filter(key => key !== "category").filter(key => key !== "subtask");
        let initialArray = ["category"];
        initialArray.push(...keysarr);
        setKeys(initialArray);
      }
    }, 100);
  };

  const headerDiv = (heading, index) => {
    return /*#__PURE__*/_react.default.createElement("div", null, heading === "category" ? /*#__PURE__*/_react.default.createElement("span", null, heading) : /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("input", {
      type: "checkbox",
      name: "".concat(heading),
      value: selectedColumns,
      onChange: e => handleColumnSelect(e)
    }), /*#__PURE__*/_react.default.createElement("span", null, heading)));
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    "data-testid": "treegrid-container",
    className: "TreeGrid-container ".concat(expanded ? "TreeGrid-container-expanded" : "TreeGrid-container-short")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "TreeGrid-list-container"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "TreeGrid-list-container-header"
  }, /*#__PURE__*/_react.default.createElement("span", null, "WorkSpace 1 ", /*#__PURE__*/_react.default.createElement("i", {
    className: "fas fa-inbox"
  }))), /*#__PURE__*/_react.default.createElement("div", {
    className: "TreeGrid-list-container-body"
  }, /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement("i", {
    className: "fas fa-search"
  }), "Search"), /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement("i", {
    className: "far fa-bell"
  }), "Notifications"), /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement("i", {
    className: "fas fa-cog"
  }), "Settings"))), /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("input", {
    placeholder: "column header",
    value: inputColumn,
    onChange: e => setInputColumn(e.target.value)
  }), /*#__PURE__*/_react.default.createElement("button", {
    onClick: () => addColumn(inputColumn)
  }, "add column")), /*#__PURE__*/_react.default.createElement("button", {
    onClick: () => handleDeleteRollup()
  }, "Delete rollup")), /*#__PURE__*/_react.default.createElement("div", null, !expanded ? /*#__PURE__*/_react.default.createElement("button", {
    className: "TreeGrid-viewbtn",
    "data-testid": "expandbutton",
    onClick: () => handleExpand()
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: "fas fa-angle-double-right"
  })) : /*#__PURE__*/_react.default.createElement("button", {
    className: "TreeGrid-viewbtn",
    onClick: () => handleCollapse(),
    "data-testid": "collapsebutton"
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: "fas fa-angle-double-left"
  })), /*#__PURE__*/_react.default.createElement("i", {
    className: "far fa-plus-square fa-lg TreeGrid-menubtn ".concat(expanded && "TreeGrid-menubtnexpanded")
  })), data && data.length > 0 && /*#__PURE__*/_react.default.createElement(_ej2ReactTreegrid.TreeGridComponent, {
    dataSource: data,
    allowReordering: "true",
    childMapping: "subtask",
    allowResizing: true,
    treeColumnIndex: 0,
    toolbar: toolbarSettings,
    editSettings: editOptions,
    dataBound: autoFit,
    ref: ref,
    queryCellInfo: customizeCell
  }, /*#__PURE__*/_react.default.createElement(_ej2ReactTreegrid.ColumnsDirective, null, keys.map((a, i) => {
    return /*#__PURE__*/_react.default.createElement(_ej2ReactTreegrid.ColumnDirective, {
      field: a,
      headerTemplate: () => headerDiv(a, i),
      visible: ["ID"].includes(a) ? false : true,
      isPrimaryKey: ["ID"].includes(a) ? true : false,
      lockColumn: ["category"].includes(a) ? true : false,
      allowResizing: ["category"].includes(a) ? false : true,
      allowEditing: ["category"].includes(a) ? true : false,
      key: a,
      width: "110px",
      textAlign: "Left"
    }); // }
  })), /*#__PURE__*/_react.default.createElement(_ej2ReactTreegrid.Inject, {
    services: [_ej2ReactTreegrid.Reorder, _ej2ReactTreegrid.Resize, _ej2ReactTreegrid.Edit, _ej2ReactTreegrid.Toolbar]
  }))));
};

var _default = /*#__PURE__*/_react.default.memo(TreeGrid);

exports.default = _default;